/*

mainform.cpp

eNeRgy - A free music player for Sony Clie NR70

Copyright (C) 2002 Tim Toner

This software is licensed under the GNU GPL. See:
http://www.gnu.org/licenses/gpl.html

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Special thanks to Rich McNeary, creator of a C++ code skeleton for
PalmOS programming, which was used in this project. See:
http://www.home.eznet.net/~rlmsmw/palmos/palmos.htm

This program was built using:
prc-tools 2.1
Palm SDK 4.0
Sony Clie SDK 3.0

*/
///////////////////////////////////////////////////////////////////////////////
// For SDK version 3.5 use the following header file.


#include <PalmOS.h>
#include <SonyCLIE.h>


///////////////////////////////////////////////////////////////////////////////
// Developer created  headers


#include "globals.h"
#include "resource.h"
#include "mainform.h"



///////////////////////////////////////////////////////////////////////////////
// Place functions related to only this form here


/***********************************************************************************
*                                                                                  *
* Boolean Main_Form_Handle_Event(EventPtr event)                                   *
*                                                                                  *
* Handles events for objects contained in this form. Control is passed to this     *
* function by ApplicationhandleEvent.                                              *
*                                                                                  *
***********************************************************************************/
Boolean Main_Form_Handle_Event(EventPtr event)
{
   Boolean handled;
   handled = false;


///////////////////////////////////////////////////////////////////////////////
// Handle events


   switch(event->eType)
   {


///////////////////////////////////////////////////////////////////////////////
// Form is opening


      case frmOpenEvent:

      // Draw the form
      FrmDrawForm(FrmGetFormPtr(event->data.frmOpen.formID));
      SongDisplay();

      // Initialize remaining form objects
      // Copy strings into fields
      // Set the focus to an object

      handled = true;
      break;


///////////////////////////////////////////////////////////////////////////////
// Form is closing.


      case frmCloseEvent:

         // Do not place alerts in this case!

         // Free handles and resources

         MsaLibClose(LibrMsa, msaLibOpenModeAlbum);
//         HRClose(LibrHR);

         handled = false;
         break;


///////////////////////////////////////////////////////////////////////////////
// Control select event

      case ctlSelectEvent:

         switch(event->data.ctlSelect.controlID)
         {
            // Button
            case BTN_PLAY:
               SongPlay();
               break;

            case BTN_PAUSE:
               SongPause();
               break;

            case BTN_STOP:
               SongStop();
               break;

            case BTN_EJECT:
               SongEject();
               break;

            case BTN_PREV:
               SongPrev();
               break;

            case BTN_NEXT:
               SongNext();
               break;

            case BTN_VOL_UP:
               VolUp();
               break;

            case BTN_VOL_DN:
               VolDn();
               break;

            default: handled = true;
         }



///////////////////////////////////////////////////////////////////////////////
// Key down event (usually hardware button presses, like the up/down buttons)


      case keyDownEvent:

         // if the up key / scroll is pressed
         if(event->data.keyDown.chr == pageDownChr)
            SongPrev();

         //if the down key / scroll is pressed
         if(event->data.keyDown.chr == pageUpChr)
            SongNext();

         if(event->data.keyDown.chr == vchrJogPush)
            SongPause();

//            if(event->data.keyDown.chr == vchrJogBack)
  //             FrmCustomAlert(ALT_INFORMATION, "Jog Back!", " ", " ");


         handled = true;
         break;


///////////////////////////////////////////////////////////////////////////////
// Menu event


      case menuEvent:

         if (event->data.menu.itemID == MNI_ABOUT) FrmAlert(ALT_ABOUT);
         if (event->data.menu.itemID == MNI_LICENSE) FrmHelp(STR_LICENSE);

         handled = true;
         break;



///////////////////////////////////////////////////////////////////////////////
// Pen event
/*
      case penDownEvent:

         handled = true;
         break;
*/
///////////////////////////////////////////////////////////////////////////////
// Default


      default:

         handled = false;
         break;

   }

   return(handled);
}
